Code to replicate experiments for ``Learned Neural Network Representations are Spread Diffusely with Redundancy''

1. ``partially_inverted_reps/finetuning.py`` contains code to train linear probes.
2. ``partially_inverted_reps/*.ipynb`` has notebooks used for analysis.
3. ``deep-learning-base`` contains helper functions for training and inference.

Requirements:

Python 3.7.9 or higher

Pip dependencies:

absl-py==1.0.0
aiohttp==3.8.1
aiosignal==1.2.0
argon2-cffi==21.3.0
argon2-cffi-bindings==21.2.0
asttokens==2.0.8
async-timeout==4.0.2
asynctest==0.13.0
attrs==21.4.0
backcall==0.2.0
bcrypt==3.2.2
beautifulsoup4==4.11.1
bleach==5.0.0
cachetools==5.0.0
certifi==2021.10.8
cffi==1.15.0
charset-normalizer==2.0.12
concentrationMetrics==0.6.0
cox==0.1.post3
cryptography==37.0.2
cycler==0.11.0
debugpy==1.6.0
decorator==5.1.1
defusedxml==0.7.1
dill==0.3.4
entrypoints==0.4
executing==0.10.0
fastjsonschema==2.15.3
fonttools==4.29.1
frozenlist==1.3.0
fsspec==2022.2.0
future==0.18.2
gitdb==4.0.9
GitPython==3.1.27
google-auth==2.6.0
google-auth-oauthlib==0.4.6
grpcio==1.44.0
idna==3.3
imageio==2.19.2
importlib-metadata==4.11.2
importlib-resources==5.7.1
iniconfig==1.1.1
ipykernel==6.13.0
ipython==7.33.0
ipython-genutils==0.2.0
ipywidgets==7.7.0
jedi==0.18.1
Jinja2==3.1.2
joblib==1.1.0
jsonschema==4.4.0
jupyter==1.0.0
jupyter-client==7.3.0
jupyter-console==6.4.3
jupyter-core==4.10.0
jupyterlab-pygments==0.2.2
jupyterlab-widgets==1.1.0
kiwisolver==1.3.2
kornia==0.6.4
littleutils==0.2.2
lpips==0.1.2
Markdown==3.3.6
MarkupSafe==2.1.1
matplotlib==3.5.1
matplotlib-inline==0.1.3
matplotlib-venn==0.11.7
mistune==0.8.4
multidict==6.0.2
nbclient==0.6.2
nbconvert==6.5.0
nbformat==5.4.0
nest-asyncio==1.5.5
networkx==2.6.3
notebook==6.4.11
numpy==1.21.5
nvidia-smi==0.1.3
oauthlib==3.2.0
packaging==21.3
pandas==1.3.5
pandocfilters==1.5.0
paramiko==2.10.4
parso==0.8.3
pexpect==4.8.0
pickleshare==0.7.5
Pillow==9.0.1
pluggy==1.0.0
prometheus-client==0.14.1
prompt-toolkit==3.0.29
protobuf==3.19.4
psutil==5.9.0
ptyprocess==0.7.0
py==1.11.0
py3nvml==0.2.7
pyasn1==0.4.8
pyasn1-modules==0.2.8
pycparser==2.21
pyDeprecate==0.3.1
Pygments==2.12.0
PyNaCl==1.5.0
pyparsing==3.0.7
pyrsistent==0.18.1
pytest==7.0.1
python-dateutil==2.8.2
pytorch-lightning==1.5.10
pytz==2021.3
PyYAML==6.0
pyzmq==22.3.0
qtconsole==5.3.0
QtPy==2.1.0
requests==2.27.1
requests-oauthlib==1.3.1
rsa==4.8
scikit-learn==1.0.2
scipy==1.7.3
seaborn==0.11.2
Send2Trash==1.8.0
six==1.16.0
smmap==5.0.0
sorcery==0.2.2
soupsieve==2.3.2.post1
-e git+ssh://git@github.com/nvedant07/STIR.git@9de86990b957a18796e7068c4bff7655a5bcc31c#egg=stir_invariance
tensorboard==2.8.0
tensorboard-data-server==0.6.1
tensorboard-plugin-wit==1.8.1
terminado==0.13.3
threadpoolctl==3.1.0
timm @ git+https://github.com/rwightman/pytorch-image-models@d07d0151738417dc754e6620656e9e9a9621aae8
tinycss2==1.1.1
tomli==2.0.1
torch==1.12.1+cu116
torchaudio==0.12.1+cu116
torchmetrics==0.7.2
torchvision==0.13.1+cu116
tornado==6.1
tqdm==4.63.0
traitlets==5.1.1
typing_extensions==4.1.1
urllib3==1.26.8
wcwidth==0.2.5
webencodings==0.5.1
Werkzeug==2.0.3
widgetsnbextension==3.6.0
wrapt==1.14.1
xmltodict==0.13.0
yarl==1.7.2
zipp==3.7.0